summaryrefslogtreecommitdiff
path: root/eclass/db.eclass
diff options
context:
space:
mode:
authorV3n3RiX <venerix@redcorelinux.org>2019-07-19 22:05:27 +0100
committerV3n3RiX <venerix@redcorelinux.org>2019-07-19 22:05:27 +0100
commit121ed4eec41fbf03e1998d09eede1bf449da63b9 (patch)
treece9341d77d1507f67d4a3a1472da9011b5baa0a8 /eclass/db.eclass
parentdd762ff83c330186ee2ede002e08b2f780cddd51 (diff)
gentoo resync : 19.07.2019
Diffstat (limited to 'eclass/db.eclass')
-rw-r--r--eclass/db.eclass70
1 files changed, 37 insertions, 33 deletions
diff --git a/eclass/db.eclass b/eclass/db.eclass
index 5227601c456f..01c2f9d9f1fc 100644
--- a/eclass/db.eclass
+++ b/eclass/db.eclass
@@ -20,47 +20,49 @@ db_fix_so() {
has "${EAPI:-0}" 0 1 2 && ! use prefix && EROOT="${ROOT}"
LIB="${EROOT}/usr/$(get_libdir)"
- cd "${LIB}"
+ cd "${LIB}" || die
# first clean up old symlinks
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so' -exec rm \{} \;
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so.[23]' -exec rm \{} \;
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -exec rm \{} \;
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so' -delete || die
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so.[23]' -delete || die
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -delete || die
# now rebuild all the correct ones
+ local ext
for ext in so a; do
for name in libdb libdb_{cxx,tcl,java,sql,stl}; do
- target=`find . -maxdepth 1 -type f -name "${name}-*.${ext}" |sort -n |tail -n 1`
- [ -n "${target}" ] && ln -sf ${target//.\//} ${name}.${ext}
+ target="$(find . -maxdepth 1 -type f -name "${name}-*.${ext}" |sort -V |tail -n 1)"
+ [[ -n "${target}" ]] && ln -sf ${target//.\//} ${name}.${ext}
done;
done;
# db[23] gets some extra-special stuff
- if [ -f libdb1.so.2 ]; then
+ if [[ -f libdb1.so.2 ]]; then
ln -sf libdb1.so.2 libdb.so.2
ln -sf libdb1.so.2 libdb1.so
ln -sf libdb1.so.2 libdb-1.so
fi
# what do we do if we ever get 3.3 ?
+ local i
for i in libdb libdb_{cxx,tcl,java,sql,stl}; do
- if [ -f $i-3.2.so ]; then
- ln -sf $i-3.2.so $i-3.so
- ln -sf $i-3.2.so $i.so.3
+ if [[ -f ${i}-3.2.so ]]; then
+ ln -sf ${i}-3.2.so ${i}-3.so
+ ln -sf ${i}-3.2.so ${i}.so.3
fi
done
# do the same for headers now
# but since there are only two of them, just overwrite them
cd "${EROOT}"/usr/include
- target=`find . -maxdepth 1 -type d -name 'db[0-9]*' | sort -n |cut -d/ -f2- | tail -n1`
- if [ -n "${target}" ] && [ -e "${target}/db.h" ] && ( ! [[ -e db.h ]] || [[ -h db.h ]] ); then
+ target="$(find . -maxdepth 1 -type d -name 'db[0-9]*' | sort -V |cut -d/ -f2- | tail -n1)"
+ if [[ -n "${target}" ]] && [[ -e "${target}/db.h" ]] && ( ! [[ -e db.h ]] || [[ -h db.h ]] ); then
einfo "Creating db.h symlinks to ${target}"
ln -sf "${target}"/db.h .
ln -sf "${target}"/db_185.h .
- elif [ ! -e "${target}/db.h" ]; then
- if [ -n "${target}" ]; then
+ elif [[ ! -e "${target}/db.h" ]]; then
+ if [[ -n "${target}" ]]; then
ewarn "Could not find ${target}/db.h"
- elif [ -h db.h ]; then
+ elif [[ -h db.h ]]; then
einfo "Apparently you just removed the last instance of $PN. Removing the symlinks"
rm -f db.h db_185.h
fi
@@ -72,7 +74,7 @@ db_src_install_doc() {
# not everybody wants this wad of documentation as it is primarily API docs
if use doc; then
dodir /usr/share/doc/${PF}/html
- mv "${ED}"/usr/docs/* "${ED}"/usr/share/doc/${PF}/html/
+ mv "${ED}"/usr/docs/* "${ED}"/usr/share/doc/${PF}/html/ || die
rm -rf "${ED}"/usr/docs
else
rm -rf "${ED}"/usr/docs
@@ -84,16 +86,17 @@ db_src_install_doc() {
db_src_install_examples() {
has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
if use examples ; then
- local langs="c cxx stl"
+ local langs=( c cxx stl )
[[ "${IUSE/java}" != "${IUSE}" ]] \
&& use java \
- && langs="${langs} java"
- for i in $langs ; do
+ && langs+=( java )
+ local i
+ for i in ${langs[@]} ; do
destdir="/usr/share/doc/${PF}/"
src="${S}/../examples_${i}/"
- if [ -f "${src}" ]; then
+ if [[ -f "${src}" ]]; then
dodir "${destdir}"
- cp -ra "${src}" "${ED}${destdir}/"
+ cp -ra "${src}" "${ED}${destdir}/" || die
fi
done
fi
@@ -102,6 +105,7 @@ db_src_install_examples() {
db_src_install_usrbinslot() {
has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
# slot all program names to avoid overwriting
+ local fname
for fname in "${ED}"/usr/bin/db*
do
dn="$(dirname "${fname}")"
@@ -116,7 +120,7 @@ db_src_install_headerslot() {
has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
# install all headers in a slotted location
dodir /usr/include/db${SLOT}
- mv "${ED}"/usr/include/*.h "${ED}"/usr/include/db${SLOT}/
+ mv "${ED}"/usr/include/*.h "${ED}"/usr/include/db${SLOT}/ || die
}
db_src_install_usrlibcleanup() {
@@ -125,24 +129,24 @@ db_src_install_usrlibcleanup() {
# Clean out the symlinks so that they will not be recorded in the
# contents (bug #60732)
- if [ "${ED}" = "" ]; then
- die "Calling clean_links while \$ED not defined"
+ if [[ "${ED}" = "" ]]; then
+ die "Calling clean_links while \${ED} not defined"
fi
- if [ -e "${LIB}"/libdb.a ] && [ ! -e "${LIB}"/libdb-${SLOT}.a ]; then
+ if [[ -e "${LIB}"/libdb.a ]] && [[ ! -e "${LIB}"/libdb-${SLOT}.a ]]; then
einfo "Moving libdb.a to a versioned name"
- mv "${LIB}/libdb.a" "${LIB}/libdb-${SLOT}.a"
+ mv "${LIB}/libdb.a" "${LIB}/libdb-${SLOT}.a" || die
fi
- if [ -e "${LIB}"/libdb_cxx.a ] && [ ! -e "${LIB}"/libdb_cxx-${SLOT}.a ]; then
+ if [[ -e "${LIB}"/libdb_cxx.a ]] && [[ ! -e "${LIB}"/libdb_cxx-${SLOT}.a ]]; then
einfo "Moving libdb_cxx.a to a versioned name"
- mv "${LIB}/libdb_cxx.a" "${LIB}/libdb_cxx-${SLOT}.a"
+ mv "${LIB}/libdb_cxx.a" "${LIB}/libdb_cxx-${SLOT}.a" || die
fi
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so' -exec rm \{} \;
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so.[23]' -exec rm \{} \;
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so' -delete || die
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*so.[23]' -delete || die
einfo "removing unversioned static archives"
- find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -exec rm \{} \;
+ find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -delete || die
rm -f \
"${ED}"/usr/include/{db,db_185}.h \
@@ -162,7 +166,7 @@ db_src_test() {
ewarn "This can take 6+ hours on modern machines"
# Fix stuff that fails with relative paths, and upstream moving files
# around...
- local test_parallel=''
+ local test_parallel='' t
for t in \
"${S}"/test/parallel.tcl \
"${S}"/../test/parallel.tcl \
@@ -188,7 +192,7 @@ db_src_test() {
echo "run_parallel $(makeopts_jobs) run_std" >> testrunner.tcl
tclsh testrunner.tcl
- egrep -qs '^FAIL' ALL.OUT* && die "Some tests failed, please see ${S}/ALL.OUT*"
+ grep -Eqs '^FAIL' ALL.OUT* && die "Some tests failed, please see ${S}/ALL.OUT*"
else
eerror "You must have USE=tcl to run the sys-libs/db testsuite."
fi